function out=Coulomb_Damper(Ext,Ext1,Dext,Dext1, Fmax,K,S,dT, Fcdi,Extri,Refi)
%  SIMULATES COULOMB DAMPER DYNAMICS.
%  EXT, EXT1= PRESENT AND PAST VALUE OF RELATIVE DISPLACEMENT ACROSS THE DAMPER
%  DEXT,DEXT1=PRESENT AND PAST VALUES OF RELATIVE RATE ACROSS THE DAMPER
%  REF= LOCATION OF REFERENCE POINT ( OUTPUT ONLY )
%  FCD= Output COULOMB DAMPER FORCE
%  DT = TIME STEP
%  ------------------------------------------------------------------
XI= S + Fmax/K;                                    %.. Dead-Zone and Complianc Region

%.. CHECK FOR FREEPLAY/COMPLIANCE REGION, Below Braking point (no damping)
if (abs(Fcdi)>=Fmax && Dext*Extri<0)               %.. Inp Force > Fmax & vel decreas
      TAU=dT*Dext1/(Dext1-Dext);                   %.. FIND TIME OF CORNER
      Ref=Ext1 + Dext1*TAU/2 + XI*sign(Dext);      %.. FIND POSITION OF NEW REFERENCE
else; Ref=Refi;                                    %.. Same Reference point as before
end

Extr=Ext-Refi;                                     %.. Extension relative to Reference

if (abs(Extr) >= XI); Fcd= Fmax*sign(Extr);        %.. Max Break Force*sign(Extr)
elseif (abs(Extr) < S); Fcd= 0;                    %.. Relat Extens in Dead-Zone, F=0
    
else                                               %.. Relat Extension Within compiance
    Fcd= K*(Extr-S*sign(Extr));                    %.. Force due to Compliance
end
out=[Fcd;Extr;Ref];