global Phdf Mdf
% Calls the Simulink model "DescFun_Sim.Mdl" that contains the non-linearity
% and computes its Describing Function
d2r=pi/180; r2d=180/pi;
EE=[0.001, 0.0011, 0.0012, 0.0013, 0.0015, 0.002, 0.003, 0.004, 0.005, ...
    0.007, 0.009, 0.011, 0.012, 0.013, 0.015, 0.02, 0.03, 0.04, ...
    0.05, 0.07, 0.1, 0.15, 0.2, 0.3, 0.5];    % List of Amplitudes
omg=0.05;                                          % One Frequency
lee=length(EE);
Cdf=zeros(lee,1); Mdf=Cdf; Phdf=Cdf;

for j=1:length(EE)
    E=EE(j);
    sim('DescFun_Sim');
    Mdf(j)=20*log10(1/sqrt(DF_real^2 + DF_imag^2));
    Cdf(j)= 1/((DF_real + sqrt(-1)*DF_imag)/-sqrt(-1));
    Phdf(j)=angle(Cdf(j))*57.295 -180;
end

figure(1); semilogx(EE,-Mdf); title('Magnitude vs Extension')
           ylabel('Gain (db)');   xlabel('Extension (ft)');
figure(2); semilogx(EE,Phdf); title('Phase vs Extension')
           ylabel('Phase (deg)'); xlabel('Extension (ft)');
figure(3); plot(Phdf,Mdf, 'LineWidth',1.5); title('-1/N(a) Gain vs Phase')
           xlabel('Phase (deg)'); ylabel('Gain (db)');
save dfdata.mat EE Phdf Mdf Cdf                    % Save the DF data
