% Program calculates the frequency response G(jw) of the plant across
% the non-linearity and overlays the -1/N(e) locus
% The intersections determine the existence of limit-cycles
global Phdf Mdf
d2r=pi/180; r2d=180/pi;
[Av1, Bv1, Cv1, Dv1]= plant_flxcont;              % Continuous Plant
[Acs, Bcs, Ccs, Dcs]= controller_s;               % Continuous Stage-2 Controller

label='Nichols Symmetric Frequ Response Across the Damper for Describ Function Analysis';
[As,Bs,Cs,Ds]= linmod('Open_Loop_DF');            % Cont. Frequ Response Model
sys=ss(As,Bs,Cs,Ds);                              % Perform Linearization
%[As,Bs,Cs,Ds]= dlinmod('Open_Loop_DF',0.002);    % Disc. Frequ Response Model
%[n,n]=size(As); E=eye(n);
%sys=dss(As,Bs,Cs,Ds,E,0.002);                    % Perform Linearization

lfr=40000; ph2=zeros(1,lfr); mg2=ph2; w=logspace(-2,2.8,lfr);  % and Frequ domain analysis
[mg,ph]= Nichols(sys,w);
for i=1:lfr                                    % Create locus of G(jw)
    ph2(i)=ph(1,1,i);
    mg2(i)=20*log10(mg(1,1,i));
end
load dfdata                                    % Load the DF data with the -1/N(a) locus
Phdf2=Phdf+2*360;                              % create another 1/N(e) locus 360 deg away
Phdf1=Phdf+1*360;                              % create another 1/N(e) locus 360 deg away

% Overlay loci
figure(1); plot(ph2,mg2, Phdf2,Mdf, Phdf1,Mdf,'LineWidth',1.5); title(label) 
figure(2); Nichols(sys,w); title(label)

