global Phdf Mdf
% Computes the Open-Loop Frequency Response for Flight Control Analysis
% Loop is opened at the Flight Control System Output
d2r=pi/180; r2d=180/pi;
[Av1, Bv1, Cv1, Dv1]= plant_flxcont;              % Continuous Plant
[Av4, Bv4, Cv4, Dv4]= plant_flxz40ms;             % Discrete Plant at 40 msec
[Acz, Bcz, Ccz, Dcz]= controller_z;               % Discrete Stage-2 Controller (T=0.04)
[Acs, Bcs, Ccs, Dcs]= controller_s;               % Continuous Stage-2 Controller (T=0)

label='Stage-2 Yaw Axis Stability, No Damper, Clamped Payload, (Roll & Pitch Loops Closed)';
[As,Bs,Cs,Ds]= dlinmod('Open_Loop_z',0.04);       % Frequ Response Model (z-domain)
[n,n]=size(As); E=eye(n);
sys=dss(As,Bs,Cs,Ds,E,0.04);                      % Perform Linearization

% [As,Bs,Cs,Ds]= linmod('Open_Loop_s');            % Frequ Response Anal Model (s-domain)
% sys=ss(As,Bs,Cs,Ds);                             % Perform Linearization

w=logspace(-2,1.9,25000);                         % and Frequ domain analysis
[mg,ph]= Nichols(sys,w);
figure(1); Nichols(sys,w); title(label)
figure(2); Bode(sys,w); title(label)

